#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <strings.h>
#include <ctype.h>
#include <netdb.h>
#include <sys/time.h>

#ifndef INADDR_NONE
#define INADDR_NONE	(u_short)-1
#endif
#define PORT 6868	 /* the port we use to run this thing on*/

main()
{
    struct sockaddr_in sock;
    struct sockaddr conn;
    struct in_addr tmpaddr;
    struct hostent *tmphost;
    char host[65], string[81];
    FILE *readfrom;
    int childid, s, ns, hostlen = 65, connsize;
    fd_set readfds;


    if ( -1 == (s=socket(AF_INET, SOCK_STREAM, 0))) {
    	perror("announce: unable to get socket");
    	exit(1);
    }

    gethostname(host, hostlen);
    printf("Attempting to start announce on host %s port %d\n", host, PORT);

    if(isdigit(*host)) {
    	if((u_short)INADDR_NONE == (tmpaddr.s_addr=inet_addr(host))) {
    		perror("announce: bad numeric address");
    		exit(2);
    	}
    } else {
    	if((struct hostent *)0 == (tmphost = gethostbyname(host))) {
    		perror("announce: bad host name");
    		exit(2);
    	}
        bcopy(tmphost->h_addr, (char *)&tmpaddr, sizeof(struct in_addr));
    }

    bcopy((char *) &tmpaddr, (char *) &(sock.sin_addr), sizeof(struct in_addr));
    sock.sin_addr.s_addr = INADDR_ANY;
    sock.sin_family = AF_INET;
    sock.sin_port = (unsigned short) htons((unsigned short) PORT);
    setsockopt(s, SOL_SOCKET, SO_REUSEADDR, (char *)0, 0);

    if(-1 == bind(s, (struct sockaddr *) &sock,sizeof(struct sockaddr_in))) {

    	perror("announce: error binding socket");
    	exit(3);
    }

    if( -1 == listen(s,5)) {
    	perror("announce: error listening");
    	exit(4);
    }

    printf("Successfully opened port.\n");
    printf("Starting daemon....\n");
    if(childid = fork()) {
        system("kill -9 `cat r.pid`");
        system("rm r.pid");
        sprintf(string, "echo \"%d\" > r.pid", childid);
        system(string);
 	exit(0);
    }

    while(1) {
	FD_ZERO(&readfds);
        FD_SET(s, &readfds);
	if(-1 != select(s+1, &readfds, (fd_set *)0, (fd_set *)0, 
            (struct timeval *)0)) {
    	    if(-1 == (ns = accept(s, &conn, &connsize)))
                break;
    	    readfrom = fopen("hotel.who", "r");
    	       while(NULL != fgets(string, 81, readfrom)) {
                   if( -1 == send(ns, string, strlen(string), 0))
                       break;
               }
	    sleep(1);
            fclose(readfrom);
            shutdown(ns, 2);
            close(ns);
        }
    }
}

